function hwiframe(element){
	return jQuery('iframe#visual-editor-contents').contents().find(element);
}


function headway_open_box(box, overrideZ, removeBox){
	var largestZ = 1;
	
	if(typeof removeBox != 'undefined' && removeBox === true){
		var box = box;
	} else {
		var box = box + '-box';
	}
	
	jQuery('div.floaty-box').each(function(){
		var currentZ = parseFloat(jQuery(this).css('zIndex'));
		
		//Exclude z-index of help box with less than 11000
		if(currentZ < 11000 && currentZ > largestZ){
			var largestZ = currentZ;
			var zIndex = largestZ + 1;
		}
	});
	
	if(typeof overrideZ != 'undefined' && overrideZ !== false){
		var zIndex = overrideZ;
	}
		
	jQuery('div#' + box).show().removeClass('leaf-options-hidden');
	jQuery('div#' + box).css('zIndex', zIndex);
}


function headway_close_box(box){
	jQuery('div#' + box + '-box').hide();
}


function headway_save_editor(animate){
	if(animate !== false){
		jQuery('span#headway-save-load').show().animate({'opacity':1}, 750, false); 		
		jQuery('input#headway-publish-button').animate({'opacity':0}, 750, false);
	}
	
	//Change title
	jQuery('title').text('Visual Editor: Publishing...');
	
	//Change menu
	jQuery('span#editing-title').hide();
	jQuery('span.link-status').hide();
	jQuery('span#visual-editor-current-page').text('Publishing...');
			
	headway_stop_ve_close();
		
	var form_data = jQuery('.visual-editor-input, .headway-visual-editor-input').serialize();
	var font_data = jQuery('.visual-editor-font-input').serialize();
	var color_data = jQuery('.visual-editor-color-input').serialize();
	var border_data = jQuery('.visual-editor-border-input').serialize();
	
	var nonce = jQuery('.visual-editor-input-nonce').val();

	jQuery.post( headway_settings['url']+'/?headway-trigger=visual-editor-action', { encoded: headway_encode64(form_data), 'headway-ve-nonce':nonce }, function(){ 
		
		jQuery.post( headway_settings['url']+'/?headway-trigger=visual-editor-action', { encoded: headway_encode64(color_data), 'headway-ve-nonce':nonce, 'truncate':'color' }, function(){
		
			jQuery.post( headway_settings['url']+'/?headway-trigger=visual-editor-action', { encoded: headway_encode64(font_data), 'headway-ve-nonce':nonce, 'truncate':'font' }, function(){
			
				jQuery.post( headway_settings['url']+'/?headway-trigger=visual-editor-action', { encoded: headway_encode64(border_data), 'headway-ve-nonce':nonce, 'truncate':'sizing' }, function(){
					
					jQuery.ajax({
						type: 'GET',
						data: {'page-id': jQuery('input#current-real-page').val(),'is-domain-mapping':headway_is_domain_mapping},
						url: headway_settings['url']+'/?headway-trigger=process&process=visual-editor-run-up&callback=?',
						async: false,
						dataType: 'json',
						success: function(data){
							headway_settings = data['headway-settings'];
							
							headway_blog_url = headway_settings['wpurl'];
														
							sizing = data['sizing'];

							headway_settings['template-directory'] = headway_template_directory;
							
							jQuery('div#visual-editor-leaf-inputs').html('');
							
							//Reset save and link box
							jQuery('div#visual-editor-hidden-inputs input#save-and-link-hidden').remove();
							jQuery('div#save-and-link-box option:selected').attr('selected', false);

							headway_allow_ve_close();
							
							jQuery('iframe#visual-editor-contents').attr('src', jQuery('iframe#visual-editor-contents').attr('src'));
						}
					});
				
				});
			
			});
		
		});
		
	});
}


function headway_element_form_name(element){
	var form_name = element.replace(/\./g, '-period-').replace(/\ /g, '-space-').replace(/\#/g, '-pound-').replace(/\,/g, '-comma-').replace(/\:/g, '-colon-');

	return form_name;
}


function headway_stop_ve_close(){	
	if(navigator.userAgent.indexOf('Chrome') == -1){
		window.onbeforeunload = function(){
			return 'You have unsaved changes.  Are you sure you wish to leave the Visual Editor?';
		}
	}
	
	allow_close = false;
}


function headway_allow_ve_close(){
	window.onbeforeunload = function(){
		return null;
	}
	
	allow_close = true;
}


function headway_disable_bad_keys(){
	//8 = Backspace
	//13 = Enter
	
	//Disable backspace for normal frame but still keep backspace functionality in inputs.  Also disable enter.
	jQuery(document).keypress(function(event){ 
		var element = jQuery(document.activeElement); 
		
		if(event.which === 8 && !element.is('input') && !element.is('textarea')){ 
			return false; 
		}; 
		
		if(event.which == 13 && !element.is('textarea')) {
			return false;
		}
	});
	
	//Disable backspace and enter for iframe
	hwiframe('html').keypress(function(event){	
		var element = jQuery(event.target);
							
		if((event.which === 8 && !element.is('input')) || event.which === 13){ 
			return false; 
		};
	});
}


function headway_encode64(input) {
	var keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
	
	var output = '';
	var chr1, chr2, chr3;
	var enc1, enc2, enc3, enc4;
	var i = 0;

	while (i < input.length) {
		chr1 = input.charCodeAt(i++);
		chr2 = input.charCodeAt(i++);
		chr3 = input.charCodeAt(i++);

		enc1 = chr1 >> 2;
		enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
		enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
		enc4 = chr3 & 63;

		if (isNaN(chr2)) {
			enc3 = enc4 = 64;
		} else if (isNaN(chr3)) {
			enc4 = 64;
		}

		output = output + keyStr.charAt(enc1) + keyStr.charAt(enc2) + keyStr.charAt(enc3) + keyStr.charAt(enc4);
   }

   return output.toString();
}