function alignment_select_function(leaf_id, value){		
	var leaf_full_id = 'leaf-'+leaf_id;
					
	if(value == 'left'){
		hwiframe('div#' + leaf_full_id).addClass('headway-leaf-left');
		hwiframe('div#' + leaf_full_id).removeClass('headway-leaf-right');
		
		if(hwiframe('div#' + leaf_full_id).hasClass('headway-leaf-clear-right')){
			hwiframe('div#' + leaf_full_id).addClass('headway-leaf-clear-left');
			hwiframe('div#' + leaf_full_id).removeClass('headway-leaf-clear-right');
		}
		
		jQuery('input#' + leaf_full_id + '_align').val('left');
	}
	
	if(value == 'right'){
		hwiframe('div#' + leaf_full_id).addClass('headway-leaf-right');
		hwiframe('div#' + leaf_full_id).removeClass('headway-leaf-left');
		
		if(hwiframe('div#' + leaf_full_id).hasClass('headway-leaf-clear-left')){
			hwiframe('div#' + leaf_full_id).addClass('headway-leaf-clear-right');
			hwiframe('div#' + leaf_full_id).removeClass('headway-leaf-clear-left');
		}
		
		jQuery('input#' + leaf_full_id + '_align').val('right');
	}
}


function clear_select_function(leaf_id, value){	
	var leaf_full_id = 'leaf-' + leaf_id;
									
	if(value == 'none'){
		hwiframe('div#' + leaf_full_id).removeClass('headway-leaf-clear-left');
		hwiframe('div#' + leaf_full_id).removeClass('headway-leaf-clear-right');
		hwiframe('div#' + leaf_full_id).removeClass('headway-leaf-clear-both');
		
		jQuery('input#' + leaf_full_id + '_clear').val('none');
	}
	
	if(value == 'same'){
		if(hwiframe('div#' + leaf_full_id).hasClass('headway-leaf-right')){
			hwiframe('div#' + leaf_full_id).addClass('headway-leaf-clear-right');
			hwiframe('div#' + leaf_full_id).removeClass('headway-leaf-clear-left');
			hwiframe('div#' + leaf_full_id).removeClass('headway-leaf-clear-both');
		} else {
			hwiframe('div#' + leaf_full_id).addClass('headway-leaf-clear-left');
			hwiframe('div#' + leaf_full_id).removeClass('headway-leaf-clear-right');
			hwiframe('div#' + leaf_full_id).removeClass('headway-leaf-clear-both');
		}
	
		
		jQuery('input#' + leaf_full_id + '_clear').val('left');
	}
	
	
	if(value == 'both'){
		hwiframe('div#' + leaf_full_id).addClass('headway-leaf-clear-both');
		hwiframe('div#' + leaf_full_id).removeClass('headway-leaf-clear-left');
		hwiframe('div#' + leaf_full_id).removeClass('headway-leaf-clear-right');
		
		jQuery('input#' + leaf_full_id + '_clear').val('both');
	}
}


function headway_ready_leafs(leaf){		
	leaf.css('position', 'relative');
	
	leaf.children('.headway-leaf-inside').prepend('<div class="leaf-icon-container"><a href="" title="This is the ID of the leaf, which is used for duplicate sidebars and advanced coding." class="ve-tooltip leaf-id"></a><div class="leaf-icon"></div></div>');
	leaf.children('.headway-leaf-inside').prepend('<div class="leaf-control"><a class="leaf-height leaf-height-fluid ve-tooltip" href="" title="Toggle fluid height of leaf.">Fluid Height</a><a class="leaf-alignment-toggle ve-tooltip" href="" title="Toggle align to left, right, or tell the leaf to start a new row.">Align/New Row</a><a class="edit ve-tooltip" href="" title="Open the options for this leaf.">Edit</a><a class="delete ve-tooltip" href="" title="Delete this leaf.">Delete</a></div><a href="#" class="precise-resize">Precise Resize</a>');
	
	var url = headway_settings['url']+'/?headway-trigger=process&process=leaf-sizes&callback=?';
	var post_data = {'page-id':jQuery('input#current-real-page').val()};
	
	if(typeof sizing == 'undefined'){
		jQuery.ajax({
			type: 'POST',
			url: url,
			data: post_data,
			async: false,
			dataType: 'json',
			success: function(data){
				sizing = data;
			}
		});	
	}
	
	leaf.each(function(){
		var leaf = jQuery(this);
		var leaf_id = leaf.attr('id').replace('leaf-', '');
		var leaf_full_id = leaf.attr('id');
		var leaf_inside = leaf.children('.headway-leaf-inside');
		var leaf_type = leaf.attr('class').split(' ');
		var leaf_type = leaf_type[0];
		var leaf_icon = jQuery('a#add-'+leaf_type).siblings('img').attr('src');
		
		//If leaf type doesn't exist, show an X to show there's an error.
		if(typeof leaf_icon == 'undefined'){
			leaf_icon = headway_settings['template-directory']+'/library/visual-editor/icons/question_mark.png';
			
			hwiframe('div#'+leaf_full_id+' .leaf-control a:not(.delete)').css({ 'position':'absolute', 'top':'-9999px', 'left':'-9999px'});
			hwiframe('div#'+leaf_full_id+' .leaf-control').css('width', '16px');
		}
		
		hwiframe('div#'+leaf_full_id+' .leaf-icon').html('<img src="' + leaf_icon + '" width="16px" height="16px" />');
		hwiframe('div#'+leaf_full_id+' .leaf-id').text(leaf_id).click(function(){ return false; });
		
		hwiframe('div#'+leaf_full_id+' .ve-tooltip').tooltip({track: true, delay: 0, showURL: false, fade: 250, id: 've-tooltip-bubble'});
		
		leaf_inside.append('\
		<div class="leaf-alignment">\
			<label for="' + leaf_full_id + '_alignment">Alignment</label>\
			<select name="" id="' + leaf_full_id + '_alignment">\
				<option value="left">Left</option>\
				<option value="right">Right</option>\
			</select>\
			\
			<label for="' + leaf_full_id + '_clear">Leaf Wrapping</label>\
			<select name="" id="' + leaf_full_id + '_clear">\
				<option value="none">None</option>\
				<option value="both">Force New Row</option>\
				<option value="same">Same Side as Alignment</option>\
			</select>\
		</div>');
		
		hwiframe('select#' + leaf_full_id + '_alignment').change(function(){						
			alignment_select_function(leaf_id, jQuery(this).val());
		});
		
		hwiframe('select#' + jQuery(this).attr('id') + '_alignment').blur(function(){			
			alignment_select_function(leaf_id, jQuery(this).val());
		});		
		
		hwiframe('select#' + jQuery(this).attr('id') + '_clear').change(function(){			
			clear_select_function(leaf_id, jQuery(this).val());
		});
		
		hwiframe('select#' + jQuery(this).attr('id') + '_clear').blur(function(){			
			clear_select_function(leaf_id, jQuery(this).val());
		});

		var fluid_height_value = '';
		var align_value = '';
		var clear_value = '';
		
		if(leaf.hasClass('fluid-height'))
			var fluid_height_value = 'true';	
		
		if(leaf.hasClass('headway-leaf-right')){
			var align_value = 'right';
			
			hwiframe('#' + leaf_full_id + '_alignment').val('right');
		} else {
			var align_value = 'left';
		}
		
		if(leaf.hasClass('headway-leaf-clear-left')){
			var clear_value = 'left';
			
			hwiframe('#' + leaf_full_id + '_clear').val('same');
		}
		
		if(leaf.hasClass('headway-leaf-clear-right')){
			var clear_value = 'right';
			
			hwiframe('#' + leaf_full_id + '_clear').val('same');
		}
		
		if(leaf.hasClass('headway-leaf-clear-both')){
			var clear_value = 'both';
			
			hwiframe('#' + leaf_full_id + '_clear').val('both');
		}
					
		jQuery('div#visual-editor-leaf-inputs').append('\
			<input type="hidden" name="leaf-switches[' + leaf_full_id + '][fluid-height]" value="' + fluid_height_value + '" id="' + leaf_full_id + '_fluid_height" class="visual-editor-input" />\
			<input type="hidden" name="leaf-switches[' + leaf_full_id + '][align]" value="' + align_value + '" id="' + leaf_full_id + '_align" class="visual-editor-input" />\
			<input type="hidden" name="leaf-switches[' + leaf_full_id + '][clear]" value="' + clear_value + '" id="' + leaf_full_id + '_clear" class="visual-editor-input" />\
			\
			<input type="hidden" name="dimensions[' + leaf_full_id + '][width]" value="" id="' + leaf_full_id + '_width" class="visual-editor-input" />\
			<input type="hidden" name="dimensions[' + leaf_full_id + '][height]" value="" id="' + leaf_full_id + '_height" class="visual-editor-input" />');
			
			
		var title_value = leaf_inside.children('.leaf-top').text().replace(/"/g, '&quot;');
		
		if(leaf_inside.children('.leaf-top').length > 0){
			leaf_inside.children('.leaf-top').attr('title', 'Double-click to edit title.').addClass('ve-tooltip').tooltip({track: true, delay: 0, showURL: false, fade: 250, positionLeft: false, id: 've-tooltip-bubble'});
			
			leaf_inside.prepend('<input type="text" value="' + title_value + '" id="' + leaf_full_id + '_title" name="title[' + leaf_id + ']" class="inline-title-edit" style="display: none;" />');			
			jQuery('#visual-editor-leaf-inputs').prepend('<input type="hidden" value="' + title_value + '" id="' + leaf_full_id + '_title" name="title[' + leaf_id + ']" class="visual-editor-input" />');
			
			leaf_inside.find('input.inline-title-edit').blur(function(){
				var value = jQuery(this).val().replace(/&quot;/g, '"');
				var leaf_id = jQuery(this).parents('.headway-leaf').attr('id');
				
				jQuery(this).hide();

				if(jQuery(this).siblings('div.leaf-top').find('a').length > 0){
					jQuery(this).siblings('div.leaf-top').find('a').html(value);
					jQuery(this).siblings('div.leaf-top').show();
				} else {
					jQuery(this).siblings('div.leaf-top').text(value).show();
				}
												
				jQuery('#' + leaf_id + '_title').val(value);
				
				leaf.children('div.leaf-control, div.leaf-icon-container').css('top', 'auto');
			});
		}
		
	});
	
	leaf_inside = leaf.children('.headway-leaf-inside');
	
	hwiframe('div.fluid-height a.leaf-height').removeClass('leaf-height-fluid');

	leaf.find('.leaf-control .leaf-height').click(function(){		
		var leaf = jQuery(this).parents('.headway-leaf');
		
		if(leaf.hasClass('fluid-height')){
			leaf.removeClass('fluid-height');	
			jQuery('input#'+leaf.attr('id') + '_fluid_height').attr('value', 'false');
			jQuery(this).addClass('leaf-height-fluid');
		} else {
			leaf.addClass('fluid-height');
			jQuery(this).removeClass('leaf-height-fluid');
			jQuery('input#'+leaf.attr('id') + '_fluid_height').attr('value', 'true');
		}
		
		headway_stop_ve_close();
				
		return false;
	});

	leaf.find('.leaf-control a.leaf-alignment-toggle').click(function(){		
		var leaf_alignment_box = jQuery(this).parents('.headway-leaf').find('div.leaf-alignment');
		
		if(leaf_alignment_box.hasClass('leaf-alignment-show')){
			leaf_alignment_box.hide();
			leaf_alignment_box.removeClass('leaf-alignment-show');
		} else {
			leaf_alignment_box.show();
			leaf_alignment_box.addClass('leaf-alignment-show');
		}

		return false;
	});
	

	leaf.hoverIntent({
		sensitivity: 5, 
		interval: 50, 
		over: function(){		
			var leaf_inside = jQuery(this).children('.headway-leaf-inside');
				
			leaf_inside.children('.leaf-control').fadeIn(200);
			leaf_inside.children('.leaf-icon-container').fadeIn(200);
			leaf_inside.children('.leaf-alignment-show').fadeIn(200);
		}, 
		timeout: 50,
		out: function(){
			var leaf_inside = jQuery(this).children('.headway-leaf-inside');
			
			leaf_inside.children('.leaf-control').fadeOut(200);
			leaf_inside.children('.leaf-icon-container').fadeOut(200);
			leaf_inside.children('.leaf-alignment').fadeOut(200);
		}
	});


	leaf.find('.leaf-control .delete').bind('click', function(){		
		var leaf = jQuery(this).parents('.headway-leaf');
						
		if(confirm('Are you sure you want to delete this leaf?') == true){
			leaf.remove();
			hwiframe('div#control-'+leaf.attr('id')).remove();
			
			if(jQuery('input#'+leaf.attr('id')+'_add').length > 0){
				jQuery('input#'+leaf.attr('id')+'_add').remove();
			}
			
			headway_serialize_leaf_order();
			
			jQuery('div#visual-editor-leaf-inputs').prepend('<input type="hidden" class="visual-editor-input" name="delete['+leaf.attr('id')+']" id="'+leaf.attr('id')+'_delete" value="true" />');
			
			headway_equal_column_heights();
			
			headway_stop_ve_close();
		}
				
		return false;
	});
	
		
	leaf.find('div.leaf-top').dblclick(function(){				
		var leaf = jQuery(this).parents('.headway-leaf');
		var leaf_id = leaf.attr('id');
		
		leaf.find('div.leaf-control, div.leaf-icon-container').css('top', '-9999px');
		
		hwiframe('div#' + leaf_id + ' input.inline-title-edit').focus();

		jQuery(this).hide();
		hwiframe('input#' + leaf_id + '_title').show().focus();
	});


	width_input_blur = function(){
		headway_stop_ve_close();
		
		var value = jQuery(this).val();
		
		if(parseInt(value) > parseInt(headway_settings['wrapper-width'])-20){
			value = headway_settings['wrapper-width']-20;
		}
		
		var leaf = jQuery(this).parents('.headway-leaf');

		leaf.css('width', value+'px');
		leaf.css('minWidth', value+'px');	
		
		jQuery('input#' + leaf.attr('id') + '_width').attr('value', value);
	}
	
	
	height_input_blur = function(){
		headway_stop_ve_close();
		
		var value = jQuery(this).val();
		var leaf = jQuery(this).parents('.headway-leaf');
		
		leaf.css('height', value+'px');
		leaf.css('minHeight', value+'px');
		
		jQuery('input#' + leaf.attr('id') + '_height').attr('value', value);
	}

	leaf.find('.width-input').blur(width_input_blur);
	leaf.find('.height-input').blur(height_input_blur);

	leaf.find('.leaf-control .edit').click(function(){
		var leaf = jQuery(this).parents('.headway-leaf');
		var leaf_id = leaf.attr('id');	

		if(jQuery('div#control-' + leaf_id).length > 0){
			headway_open_box('control-' + leaf_id, false, true);
		} else {
			var leaf_type = leaf.attr('class').split(' ');				
			load_leaf_options(leaf_id, leaf_type[0]);
		}

		return false;
	});

	leaf.find('a.precise-resize').click(function(){
		this_leaf = jQuery(this).parent();
		this_dimensions = jQuery(this).siblings('div.leaf-dimensions');

		if(this_dimensions.length > 0){
			this_dimensions.show();	
		} else {
			var size = new Object;

			if(typeof sizing[this_leaf.attr('id')] == 'undefined' || sizing[this_leaf.attr('id')]['new-leaf'] == true){
				size['width'] = Math.round(parseInt(this_leaf.width()));
				size['height'] = Math.round(parseInt(this_leaf.css('height').replace('px', '')));
			} else {
				size['width'] = Math.round(parseInt(sizing[this_leaf.attr('id')]['width']));
				size['height'] = Math.round(parseInt(sizing[this_leaf.attr('id')]['height']));
			}
			
			jQuery('\
				<div class="leaf-dimensions">\
						<div class="dimension dimension-width">\
							<label for="' + this_leaf.attr('id') + '_width">Width</label>\
							<input type="text" id="' + this_leaf.attr('id') + '_width" value="' + size['width'] + '" class="width-input" />\
							<span>px</span>\
						</div>\
						<div class="dimension dimension-height">\
							<label for="' + this_leaf.attr('id') + '_height">Height</label>\
							<input type="text" id="' + this_leaf.attr('id') + '_height" value="' + size['height'] + '" class="height-input" />\
							<span>px</span>\
						</div>\
					</div>')
					.appendTo(this_leaf)
					.show();
					
			this_leaf.find('.width-input').blur(width_input_blur);
			this_leaf.find('.height-input').blur(height_input_blur);
		}

		jQuery(this).hide();

		return false;
	});
	
	if(leaf.parent('.resize-container').length > 0 || leaf.parent('.resize-column').length > 0){
		width = parseInt(hwiframe('div.container').width())-parseInt(headway_settings['leaf-padding'])*2-parseInt(headway_settings['leaf-margins'])*2;
		
		leaf.resizable({
			maxWidth: width,
			resize: function(event, ui) { 
				this_leaf = jQuery(this);
				this_id = this_leaf.attr('id');
				
				width = ui.size.width;
				height = ui.size.height;

				this_leaf.css('minWidth', width);
				this_leaf.css('minHeight', height);
				
				if(!this_leaf.parent().hasClass('leafs-column')){					
					jQuery('input#' + jQuery(this).attr('id') + '_width').attr('value', ui.size.width);
				}
				
				jQuery('input#' + jQuery(this).attr('id') + '_height').attr('value', ui.size.height);
				
				jQuery('input#' + jQuery(this).attr('id') + '_height_changed').attr('value', 'true');
				
				this_leaf.find('.width-input').attr('value', ui.size.width);
				this_leaf.find('.height-input').attr('value', ui.size.height);
				
				headway_stop_ve_close();
			}
		});
		leaf.addClass('resize');
		
		leaf.find('a.precise-resize').show();
		
		leaf.css('borderWidth', (parseInt(headway_settings['leaf-margins'])-1)+'px');
		leaf.css('margin', '1px');
	}

	
	if(leaf.parent('.resize-column').length > 0){
		leaf.css('borderWidth', '0 0 ' + ((parseInt(headway_settings['leaf-margins'])-1)*2)+'px');
		leaf.css('margin', '0 0 1px 0');
	}
}


function headway_serialize_leaf_order(){
	if(jQuery('a#toggle-arrange').data('enabled') != true){
		headway_leafs_sortable();
	}
		
	if(hwiframe('div.leafs-column').length > 1){
		hwiframe('div.leafs-column').each(function(){
			var column = jQuery(this).attr('id').match(/\d+-/g)[0].replace('-', '');
			var layout_order = jQuery(this).sortable('serialize');
			
			if(jQuery('input#column-' + column + '-layout-order').length === 0){
				jQuery('<input type="hidden" name="layout-order[' + column + ']" id="column-' + column + '-layout-order" value="' + layout_order + '" class="visual-editor-input" />').appendTo('div#visual-editor-hidden-inputs');
			}
			
			jQuery('input#column-' + column + '-layout-order').attr('value', layout_order);
		});
		
		if(hwiframe('div#top-container').length == 1){
			var top_container_layout_order = hwiframe('div#top-container').sortable('serialize');
			
			if(jQuery('input#top-container-layout-order').length === 0){
				jQuery('<input type="hidden" name="layout-order[top]" id="top-container-layout-order" value="' + top_container_layout_order + '" class="visual-editor-input" />').appendTo('div#visual-editor-hidden-inputs');
			}
			
			jQuery('input#top-container-layout-order').attr('value', top_container_layout_order);
		}
		
		if(hwiframe('div#bottom-container').length == 1){
			var bottom_container_layout_order = hwiframe('div#bottom-container').sortable('serialize');
			
			if(jQuery('input#bottom-container-layout-order').length === 0){
				jQuery('<input type="hidden" name="layout-order[bottom]" id="bottom-container-layout-order" value="' + bottom_container_layout_order + '" class="visual-editor-input" />').appendTo('div#visual-editor-hidden-inputs');
			}
			
			
			jQuery('input#bottom-container-layout-order').attr('value', bottom_container_layout_order);
		}
	} else {
		var layout_order = hwiframe('div.container').sortable('serialize');
		
		if(jQuery('input#layout-order').length === 0){
			jQuery('<input type="hidden" name="layout-order" id="layout-order" value="' + layout_order + '" class="visual-editor-input" />').appendTo('div#visual-editor-hidden-inputs');
		}
	
		jQuery('input#layout-order').attr('value', layout_order);
	}
	
	if(jQuery('a#toggle-arrange').data('enabled') != true){
		hwiframe('div.container').sortable('destroy');
	}
}


function headway_leafs_sortable(){
	hwiframe('div.container').addClass('sortable-leafs').sortable({
		sortableDocument: jQuery('iframe#visual-editor-contents').contents()[0],
		opacity:  0.35,
		forcePlaceholderSize: true,
		items: 'div.headway-leaf',
		connectWith: hwiframe('.container'),
		scroll: true,
		tolerance: 'pointer',
		update: function(){ 
			headway_serialize_leaf_order();
					
			headway_equal_column_heights();

			headway_stop_ve_close();
		},
		start: function(event, ui){	
			ui.helper.css('width', ui.item.parents('div.leafs-column').width() + 'px !important');
			
			ui.placeholder.css('minHeight', ui.item.height() - 1);
			ui.placeholder.css('height', ui.item.height() - 1);
		}
	});
}


function load_leaf_options(leaf_id, leaf_type, hide){		
	jQuery('div#visual-editor-boxes').prepend('<div id="control-' + leaf_id + '" class="floaty-box leaf-options leaf-options-hidden"><p class="loading"><img src="' + headway_settings['template-directory'] + '/library/shared-media/images/loading.gif" class="loading-image" /></p></div>');
	
	jQuery.ajax({
		type: 'POST',
		data: {'leaf': leaf_type, 'id': leaf_id},
		url: headway_settings['url']+'/?headway-trigger=process&process=get-leaf-options-width',
		async: false,
		success: function (data) {				
		    leaf_options_width = data;
		}
	})
	
	if(typeof leaf_options_width == 'undefined'){
		leaf_options_width = 350;
	}
	
	jQuery('div#control-' + leaf_id).load(headway_settings['url']+'/?headway-trigger=process&process=leaf-options', {'leaf':leaf_type, 'id':leaf_id}, function(){
		height = jQuery('div#control-'+leaf_id).height();
		
		jQuery('.ve-tooltip').tooltip({track: true, delay: 0, showURL: false, fade: 250, positionLeft: false, id: 've-tooltip-bubble'});

		jQuery('div#control-'+leaf_id).width(parseInt(leaf_options_width));
		jQuery('div#control-'+leaf_id+' div.tabs ul.tabs').width(parseInt(leaf_options_width));

		jQuery('div#control-'+leaf_id).resizable({minWidth: leaf_options_width, minHeight: 200, alsoResize: 'div#control-'+leaf_id+' tr.textarea textarea, div#control-'+leaf_id+' ul.tabs'});
		jQuery('div#control-'+leaf_id).draggable({ 
			opacity: 0.35,
			handle:'h4.floaty-box-header',
			start: function(event, ui){			
				largestZ = 0;

				jQuery('div.floaty-box:not(.no-drag)').each(function(){
					var currentZ = parseFloat(jQuery(this).css('zIndex'));

					//Exclude z-index of help box with less than 11000
					if(currentZ < 11000 && currentZ > largestZ){
						largestZ = currentZ;
						zIndex = largestZ + 1;
					}
				});

				jQuery(this).css('zIndex', zIndex);
			}
		});

		jQuery('div#control-'+leaf_id+' div.tabs').tabs();

		jQuery('div#control-'+leaf_id+' h4.floaty-box-header').append('<a class="close window-top-right" href="#">X</a>');


		jQuery('div#control-'+leaf_id+' h4.floaty-box-header a.close').click(function(){
			jQuery(this).parent().parent().hide();

			return false;
		});

		jQuery('div#control-'+leaf_id+' a.rotator-add-image').click(function(){
			table = jQuery(this).parent().parent().parent();

			if(jQuery(this).parent().parent().siblings('tr:last').length > 0){
				last_id = jQuery(this).parent().parent().siblings('tr:last').attr('class').replace('image-', '');
			} else {
				last_id = 0;
			}
			image_id = parseInt(last_id) + 1;
			leaf_id = jQuery(this).parent().attr('class');

			jQuery('div#control-item_'+leaf_id).css('height', 'auto');

			content = '\
				<tr id="' + leaf_id + '_rotator_image_' + image_id + '" class="image-' + image_id + '">\
					<th scope="row"><label for="' + leaf_id + '_rotator_image_' + image_id + '_url">Image ' + image_id + '</label></th>\
					<td>\
						<label for="' + leaf_id + '_rotator_image_' + image_id + '_url">Image URL</label><input type="text" name="leaf-options[' + leaf_id + '][images][' + image_id + '][path]" id="' + leaf_id + '_rotator_image_' + image_id + '_url" value="" class="visual-editor-input" />\
						<label for="' + leaf_id + '_rotator_image_' + image_id + '_hyperlink">Image Hyperlink</label><input type="text" name="leaf-options[' + leaf_id + '][images][' + image_id + '][hyperlink]" id="' + leaf_id + '_rotator_image_' + image_id + '_hyperlink" value="" class="visual-editor-input" />\
					</td>\
					<td>\
						<a href="" title="Delete This Image" class="rotator-delete-image"><img src="' + headway_settings['template-directory'] + '/library/shared-media/icons/minus.png" /></a>\
					</td>\
				</tr>';

			table.append(content);

			jQuery('tr#' + leaf_id + '_rotator_image_' + image_id + ' a.rotator-delete-image').click(function(){
				if(confirm('Are you sure?') == true) jQuery(this).parent().parent().remove();
				return false;
			});


			return false;
		});

		jQuery('div#control-'+leaf_id+' a.rotator-delete-image').click(function(){
			if(confirm('Are you sure?') == true) jQuery(this).parent().parent().remove();
			return false;
		});		
				
		jQuery.ajax({
			url: headway_settings['url']+'/?headway-trigger=process&process=options-js',
			data: {'leaf': leaf_type, 'id': leaf_id},
			type: 'POST',
			dataType: 'script'
		});
	});
		
	if(typeof hide == 'undefined' || !hide){
		headway_open_box('control-' + leaf_id, false, true);
	}
}


function headway_columns_sortable(){			
	headway_equal_column_heights();
	
	hwiframe('div#columns-container').sortable({
		opacity:  0.35,
		forcePlaceholderSize: true,
		items: 'div.leafs-column',
		scroll: false,
		tolerance: 'pointer',
		update: function(){ 			
			hwiframe('div.leafs-column').removeClass('last-leafs-column');
			hwiframe('div.leafs-column').last().addClass('last-leafs-column');
			
			var column_order = hwiframe('div#columns-container').sortable('serialize');
			
			if(jQuery('input#column-order').length === 0){
				jQuery('<input type="hidden" name="column-order" id="column-order" value="' + column_order + '" class="visual-editor-input" />').appendTo('div#visual-editor-hidden-inputs');
			}
			
			jQuery('input#column-order').val(column_order);

			hwiframe('div.leafs-column').removeClass('leafs-column-1');
			hwiframe('div.leafs-column').removeClass('leafs-column-2');
			hwiframe('div.leafs-column').removeClass('leafs-column-3');
			hwiframe('div.leafs-column').removeClass('leafs-column-4');
			
			column_foreach = 1;
			
			hwiframe('div.leafs-column').each(function(){				
				jQuery(this).addClass('leafs-column-' + column_foreach);
				column_foreach++;
			});
			
			if(hwiframe('div.leafs-column-1').length == 1 && hwiframe('div.leafs-column-2').length == 1){
				headway_resize_columns(1, 2);
			}

			if(hwiframe('div.leafs-column-2').length == 1 && hwiframe('div.leafs-column-3').length == 1){
				headway_resize_columns(2, 3);
			}

			if(hwiframe('div.leafs-column-3').length == 1 && hwiframe('div.leafs-column-4').length == 1){
				headway_resize_columns(3, 4);
			}
			
			order = hwiframe('div#columns-container').sortable('toArray');

			for(var index = 0; index < order.length; index++) {
				page_id = hwiframe('div.leafs-column-1').attr('id').match(/(-)(page)(-)((?:[a-z0-9_-]*))/)[0];

				order[index] = parseInt(order[index].replace(page_id, '').replace('column-', ''));
			}
									
			jQuery('tr#column-' + order[0] + '-width-row').appendTo('table#column-widths').find('th label').text('Column 1');
			jQuery('tr#column-' + order[1] + '-width-row').appendTo('table#column-widths').find('th label').text('Column 2');
			jQuery('tr#column-' + order[2] + '-width-row').appendTo('table#column-widths').find('th label').text('Column 3');
			jQuery('tr#column-' + order[3] + '-width-row').appendTo('table#column-widths').find('th label').text('Column 4');
			
			headway_stop_ve_close();
		},
		start: function(event, ui){			
			ui.placeholder.css('width', parseInt(ui.item.css('width'))-1);
			ui.placeholder.css('height', parseInt(ui.item.css('height'))-1);
		
			ui.placeholder.css('borderRightWidth', 1);
			ui.placeholder.css('paddingRight', 9);
			ui.placeholder.css('paddingBottom', 9);
			
			hwiframe('div.leafs-column').addClass('last-leafs-column');
		},
		stop: function(){
			hwiframe('div.leafs-column').removeClass('last-leafs-column');
			hwiframe('div.leafs-column').last().addClass('last-leafs-column');
		}
	});
	
	hwiframe('div.leafs-column').css('cursor', 'move');
}


function headway_bind_column_width_input(column_main, column_alt){
	jQuery('input#column-' + column_main + '-width').bind('blur', function(){		
		page_id = hwiframe('div.leafs-column-1').attr('id').match(/(-)(page)(-)((?:[a-z0-9_-]*))/)[0];
		
		column_main_obj = hwiframe('div#column-' + column_main + page_id);
		column_alt_obj = hwiframe('div#column-' + column_alt + page_id);
		
		column_main_width = column_main_obj.width();
		column_alt_width = column_alt_obj.width();
		
		difference = column_main_width - jQuery(this).val();
		column_alt_width_computed = parseInt(column_alt_width + difference);

		if(isNaN(jQuery(this).val())){
			jQuery(this).val(column_main_width);
			return false;
		}
		
		if(jQuery(this).val() < 120){
			jQuery(this).val(column_main_width);
			return false;
		}
		
		if(column_alt_width_computed < 120){
			jQuery(this).val(column_main_width);
			jQuery('input#column-' + column_alt + '-width').val(column_alt_width);
			
			return false;
		}
		
		column_main_obj.css('width', jQuery(this).val() + 'px');
		column_alt_obj.css('width', column_alt_width_computed + 'px');

		jQuery('input#column-' + column_alt + '-width').val(column_alt_width_computed);
		
		return;
	});
	
	return;
}


function headway_bind_column_width_inputs(columns){	
	if(columns == 2){
		headway_bind_column_width_input(1, 2);
		headway_bind_column_width_input(2, 1);
	} else if(columns == 3){
		headway_bind_column_width_input(1, 2);
		headway_bind_column_width_input(2, 1);
		headway_bind_column_width_input(3, 2);
	} else if(columns == 4){
		headway_bind_column_width_input(1, 2);
		headway_bind_column_width_input(2, 1);
		headway_bind_column_width_input(3, 2);
		headway_bind_column_width_input(4, 3);
	}
	
	return;
}


function headway_resize_columns(column_1, column_2){
	hwiframe('div.leafs-column-'+column_1).resizable({
		maxWidth: hwiframe('div#wrapper').width(),
		minWidth: 170,
		handles: 'e',
		resize: function(event, ui) { 			
			main_column = jQuery(this);
			main_column_width = ui.size.width;

			other_column = hwiframe('div.leafs-column-'+column_2);
			
			//Get the difference between the size when first resizing to what it is after resizing
			difference = ui.originalSize.width - ui.size.width;

			//Other column width is original width starting out plus the difference of the main column's starting width and current width
			other_column_width = parseInt(other_column_original_width) + parseInt(difference);
			
			//Get the current total of the two columns
			total_now = other_column_width + parseInt(main_column.css('width').replace('px', ''));
		
			//To soothe the jumpiness, find the deviation by taking the original total of the two column widths and the total now and subtrace the deviation from the new other column's width
			deviation = total_now - total_original;
			other_column_width = other_column_width - deviation;
			
			other_column.css('width', other_column_width + 'px');

			page_id = hwiframe('div.leafs-column-'+column_1).attr('id').match(/(-)(page)(-)((?:[a-z0-9_-]*))/)[0];
			
			column_1_real_width = parseInt(hwiframe('div#column-'+column_1+page_id).width());
			column_2_real_width = parseInt(hwiframe('div#column-'+column_2+page_id).width());
			
			//Don't allow the resizable to crush the other column.  Allow this to only be set once to avoid jumpiness						
			if(set_max_width != true){	
				offense = 170 - column_2_real_width;
									
				jQuery(this).resizable('option', 'maxWidth', column_1_real_width - offense);
										
				set_max_width = true;
			}
			
			jQuery('input#column-' + column_1 + '-width').val(column_1_real_width);
			jQuery('input#column-' + column_2 + '-width').val(column_2_real_width);
		},
		start: function(event, ui){
			set_max_width = false;

			jQuery(this).resizable('option', 'maxWidth', hwiframe('div#wrapper').width());
			
			other_column_original_width = hwiframe('div.leafs-column-'+column_2).css('width').replace('px', '');
			total_original = parseInt(other_column_original_width) + parseInt(jQuery(this).css('width'));
		}
	});

}


function headway_bind_template_select_option(element){
	jQuery(element).click(function(){
		jQuery(this).siblings('div.selected-option').removeClass('selected-option');
		jQuery(this).addClass('selected-option');
		
		jQuery('a#load-template').show();
	});
		
	jQuery(element).children('.template-select-edit').click(function(){	
		headway_edit_template(jQuery(this).parent());
	});
}


function headway_edit_template(option){
	option_text = option.children('span.select-option-text');
	rename_input = jQuery('input#rename-template');
	rename_input.val(option_text.html().replace('<small id="default-template">Default</small>', ''));
	
	jQuery('input#template-settings-template-id').val(option.attr('id'));
	jQuery('input#template-settings-template-name').val(option_text.html().replace('<small id="default-template">Default</small>', ''));
	
	if(option_text.children('#default-template').length == 1){
		jQuery('#remove-template-as-default').show();
		jQuery('#set-template-as-default').hide();
	} else {
		jQuery('#set-template-as-default').show();
		jQuery('#remove-template-as-default').hide();
	}
	
	headway_open_box('edit-template');
}


function headway_equal_column_heights(){
	if(jQuery('input#disable-equal-column-heights').is(':checked')) return false;
	
	hwiframe('div.leafs-column').css('height', 'auto');
	
	max_height = 0;
	
	hwiframe('div.leafs-column').each(function(){			
		if(jQuery(this).height() > max_height){
			max_height = jQuery(this).height();
		}
	});
			
	hwiframe('div.leafs-column').css('height', max_height + 'px');
}


function headway_visual_editor_leafs(){
	
	enable_column_arrange_resize = function(){
		headway_columns_sortable();
				
		if(hwiframe('div.leafs-column-1').length == 1 && hwiframe('div.leafs-column-2').length == 1){
			headway_resize_columns(1, 2);
		}

		if(hwiframe('div.leafs-column-2').length == 1 && hwiframe('div.leafs-column-3').length == 1){
			headway_resize_columns(2, 3);
		}

		if(hwiframe('div.leafs-column-3').length == 1 && hwiframe('div.leafs-column-4').length == 1){
			headway_resize_columns(3, 4);
		}
		
		jQuery('a#toggle-column-arrange-resize').text('Disable');
	}
	
	disable_column_arrange_resize = function(){
		if(hwiframe('div.leafs-column-1').length == 1 && hwiframe('div.leafs-column-2').length == 1){
			hwiframe('div.leafs-column-1').resizable('destroy');	
		}

		if(hwiframe('div.leafs-column-2').length == 1 && hwiframe('div.leafs-column-3').length == 1){
			hwiframe('div.leafs-column-2').resizable('destroy');	
		}

		if(hwiframe('div.leafs-column-3').length == 1 && hwiframe('div.leafs-column-4').length == 1){
			hwiframe('div.leafs-column-3').resizable('destroy');	
		}
		
		hwiframe('div#columns-container').sortable('destroy');
		
		hwiframe('div.leafs-column').css('cursor', 'default');				
						
		jQuery('a#toggle-column-arrange-resize').text('Enable');
	}

	enable_leaf_resize = function(){
		if(hwiframe('div.container').length > 1){
			if(hwiframe('div#top-container').length !== 0){
				width = parseInt(hwiframe('div#top-container').width())-parseInt(headway_settings['leaf-padding'])*2-parseInt(headway_settings['leaf-margins'])*2;
			} else {
				width = parseInt(hwiframe('div#bottom-container').width())-parseInt(headway_settings['leaf-padding'])*2-parseInt(headway_settings['leaf-margins'])*2;
			}
		} else {
			width = parseInt(hwiframe('div#container').width())-parseInt(headway_settings['leaf-padding'])*2-parseInt(headway_settings['leaf-margins'])*2;
		}
		
		hwiframe('div.headway-leaf').resizable({
			maxWidth: width,
			minWidth: 95,
			resize: function(event, ui) { 
				this_leaf = jQuery(this);
				this_id = this_leaf.attr('id');
				
				width = ui.size.width;
				height = ui.size.height;

				this_leaf.css('minWidth', width);
				this_leaf.css('minHeight', height);
				
				if(!this_leaf.parent().hasClass('leafs-column')){					
					jQuery('input#' + jQuery(this).attr('id') + '_width').attr('value', ui.size.width);
				}
				
				jQuery('input#' + jQuery(this).attr('id') + '_height').attr('value', ui.size.height);
				
				jQuery('input#' + jQuery(this).attr('id') + '_height_changed').attr('value', 'true');
				
				this_leaf.find('.width-input').attr('value', ui.size.width);
				this_leaf.find('.height-input').attr('value', ui.size.height);
				
				headway_stop_ve_close();
			}
		});
		jQuery('a#toggle-resize').text('Disable');
			
		hwiframe('div.leafs-container').addClass('resize-container');
		hwiframe('div#container').addClass('resize-container');
		
		hwiframe('div.leafs-column').addClass('resize-column');
		
		hwiframe('div.headway-leaf').addClass('resize');
		
		//Modify settings of all leafs
		hwiframe('div.resize').css('borderWidth', (parseInt(headway_settings['leaf-margins'])-1)+'px');
		hwiframe('div.resize').css('margin', '1px');

		//Modify settings of leafs in columns
		hwiframe('div.leafs-column div.resize').css('borderWidth', '0 0 ' + (((parseInt(headway_settings['leaf-margins']))*2)-1)+'px');
		hwiframe('div.leafs-column div.resize').css('margin', '0 0 1px 0');
		
		if(hwiframe('div.container').length == 1){			
			hwiframe('div.container').css({padding: 0, borderWidth: headway_settings['leaf-container-vertical-padding']+'px '+headway_settings['leaf-container-horizontal-padding']+'px'});
		} else {			
			hwiframe('div.resize-column').each(function(){
				jQuery(this).data('borderRightWidth', parseInt(jQuery(this).css('borderRightWidth').replace('px', '')));
				jQuery(this).data('paddingRight', parseInt(jQuery(this).css('paddingRight').replace('px', '')));
				
				column_padding_top = parseInt(jQuery(this).css('paddingTop').replace('px', ''));
				column_padding_right = parseInt(jQuery(this).css('paddingRight').replace('px', '')) + parseInt(jQuery(this).css('borderRightWidth').replace('px', ''));
				column_padding_bottom = parseInt(jQuery(this).css('paddingBottom').replace('px', ''));
				column_padding_left = parseInt(jQuery(this).css('paddingLeft').replace('px', ''));
								
				jQuery(this).css({
					borderTopWidth: column_padding_top, 
					borderRightWidth: column_padding_right, 
					borderBottomWidth: column_padding_bottom, 
					borderLeftWidth: column_padding_left,
					padding: 0
				});
			});
			
			hwiframe('div.resize-container').each(function(){								
				jQuery(this).data('borderTopWidth', parseInt(jQuery(this).css('borderTopWidth').replace('px', '')));
				jQuery(this).data('paddingTop', parseInt(jQuery(this).css('paddingTop').replace('px', '')));
				
				jQuery(this).data('borderBottomWidth', parseInt(jQuery(this).css('borderBottomWidth').replace('px', '')));
				jQuery(this).data('paddingBottom', parseInt(jQuery(this).css('paddingBottom').replace('px', '')));
				
				container_padding_top = parseInt(jQuery(this).css('paddingTop').replace('px', '')) + parseInt(jQuery(this).css('borderTopWidth').replace('px', ''));
				container_padding_right = parseInt(jQuery(this).css('paddingRight').replace('px', ''));
				container_padding_bottom = parseInt(jQuery(this).css('paddingBottom').replace('px', '')) + parseInt(jQuery(this).css('borderBottomWidth').replace('px', ''));
				container_padding_left = parseInt(jQuery(this).css('paddingLeft').replace('px', ''));
				
				jQuery(this).css({
					borderTopWidth: container_padding_top, 
					borderRightWidth: container_padding_right, 
					borderBottomWidth: container_padding_bottom, 
					borderLeftWidth: container_padding_left,
					padding: 0
				});
			});
		}
		
		hwiframe('div.container div.headway-leaf a.precise-resize').show();
		
		return false;
	}

	disable_leaf_resize = function(){
		jQuery('a#toggle-resize').text('Enable');
		
		hwiframe('div.headway-leaf').resizable('destroy');
		hwiframe('div.headway-leaf').removeClass('resize');
		
		hwiframe('div.leafs-container, div#container').removeClass('resize-container');
		hwiframe('div.leafs-column').removeClass('resize-column');
		
		hwiframe('div.headway-leaf').css({borderWidth: 'normal', margin: headway_settings['leaf-margins']+'px'});
		jQuery('div.leafs-column div.headway-leaf').css({borderWidth: 'normal', margin: '0 0 ' + (parseInt(headway_settings['leaf-margins'])*2) + 'px'});
		
		if(hwiframe('div.container').length == 1){
			hwiframe('div.container').css({padding: headway_settings['leaf-container-vertical-padding']+'px '+headway_settings['leaf-container-horizontal-padding']+'px', borderWidth: 'normal'});
		} else {
			jQuery('div.leafs-column').each(function(){
				padding = parseInt(jQuery(this).css('borderLeftWidth').replace('px', ''));
								
				jQuery(this).css({
					borderTopWidth: 0, 
					borderRightWidth: jQuery(this).data('borderRightWidth'), 
					borderBottomWidth: 0, 
					borderLeftWidth: 0,
					padding: padding,
					paddingRight: jQuery(this).data('paddingRight')
				});
			});
			
			
			jQuery('div.leafs-container').each(function(){
				padding = parseInt(jQuery(this).css('borderRightWidth').replace('px', ''));
				padding_top = parseInt(jQuery(this).css('borderTopWidth').replace('px', ''));
				padding_bottom = parseInt(jQuery(this).css('borderBottomWidth').replace('px', ''));

				
				jQuery(this).css({
					borderTopWidth: jQuery(this).data('borderTopWidth'), 
					borderRightWidth: 0, 
					borderBottomWidth: jQuery(this).data('borderBottomWidth'), 
					borderLeftWidth: 0,
					padding: padding,
					paddingTop: padding_top-jQuery(this).data('borderTopWidth'),
					paddingBottom: padding_bottom-jQuery(this).data('borderBottomWidth')
				});
			});
		}
				
		hwiframe('div.container div.headway-leaf a.precise-resize').hide();
		hwiframe('div.container div.headway-leaf div.leaf-dimensions').hide();
		
		
		return false;
	}

	enable_leaf_arrange = function(){
		headway_leafs_sortable();
		
		//Get Sortable Going
		hwiframe('div.container div.headway-leaf').css('cursor', 'move');
		
		jQuery('a#toggle-arrange').text('Disable');
		jQuery('a#toggle-arrange').data('enabled', true);
		
		return false;	
	}
	
	disable_leaf_arrange = function(){
		hwiframe('div.container').sortable('destroy');
		jQuery('a#toggle-arrange').text('Enable');
		
		jQuery('a#toggle-arrange').data('enabled', false);

		hwiframe('div.container div.headway-leaf').css('cursor', 'pointer');
		
		return false;
	}

	jQuery('a#toggle-resize').toggle(enable_leaf_resize, disable_leaf_resize);
	jQuery('a#toggle-arrange').toggle(enable_leaf_arrange, disable_leaf_arrange);
	jQuery('a#toggle-column-arrange-resize').toggle(enable_column_arrange_resize, disable_column_arrange_resize);

	jQuery('ul.add-leafs li a').click(function(){
		headway_stop_ve_close();
		
		leaf_nice_type = jQuery(this).siblings('span').text().replace(' Leaf', '');
		leaf_class = jQuery(this).parent().attr('class').replace('add-', '').replace(' alt', '');
				
		headway_settings['last-leaf-id'] = parseInt(headway_settings['last-leaf-id']) + 1;
		
		hwiframe('div.container').each(function(){
			content = '<div id="leaf-' + headway_settings['last-leaf-id'] + '" class="' + leaf_class + ' headway-leaf" style="position: relative; cursor: pointer;">\
				<div class="headway-leaf-inside">\
				<div class="leaf-top" unselectable="on" style="-moz-user-select: none; cursor: pointer;">' + leaf_nice_type + '</div>\
				\
				<div class="leaf-content" style="cursor: pointer;">\
				\
					Customize the leaf settings to your heart\'s desire then publish to view your changes.\
				\
				</div>\
				</div>\
			</div>';
			
			if(jQuery(this).hasClass('leafs-column')){
				jQuery(this).prepend(content);
			} else {
				jQuery(this).append(content);
			}
			
			return false;
		});
						
		headway_ready_leafs(hwiframe('#leaf-'+headway_settings['last-leaf-id']));
		load_leaf_options('leaf-'+headway_settings['last-leaf-id'], leaf_class, true);
		
		if(leaf_class == 'content' || leaf_class == 'sidebar'){
			hwiframe('div#leaf-' + headway_settings['last-leaf-id']).find('a.leaf-height-fluid').trigger('click');
		}
		
		headway_equal_column_heights();
		
		headway_serialize_leaf_order();
		
		jQuery('div#visual-editor-leaf-inputs').prepend('<input type="hidden" name="add[leaf-'+headway_settings['last-leaf-id']+']" id="leaf-'+headway_settings['last-leaf-id']+'_add" value="' + leaf_class + '" class="visual-editor-input headway-add-leaf-input" />');
		
		return false;
	});
		
	jQuery('select#leaf-columns').change(function(){	
		if(jQuery(this).val() == 1){
			jQuery('div.leaf-column-settings').hide();
			jQuery('li.column-arrange-resize').hide();
		} else {						
			if(jQuery(this).val() != headway_settings['page-config']['leaf-columns']){	
				jQuery('div#leaf-columns-widths').hide();
				jQuery('li.column-arrange-resize').hide();
			} else {
				jQuery('div.leaf-column-settings').show();
				jQuery('li.column-arrange-resize').show();
			}	
		}
	});
	
	headway_bind_template_select_option('div#template-selector div.select-option');
	
	jQuery('a#load-template').click(function(){		
		if(confirm('Are you sure?  Loading a template will replace the current leafs.') !== true) return false;
		
		if(jQuery('div#template-selector .selected-option').length == 0){
			alert('Please select a leaf template to load.');
			
			return false;
		}
		
		var template_name = jQuery('div#template-selector .selected-option span.select-option-text').html().replace('<small id="default-template">Default</small>', '');
		var template_id = jQuery('div#template-selector .selected-option').attr('id').replace('template-', '');
		
		var current_page = jQuery('input#current-real-page').val();
						
		jQuery('div#visual-editor-working').show().animate({'opacity':1}, 250);
		jQuery('div#ve-working-overlay').show().animate({'opacity':1}, 250, false, function(){
			jQuery.ajax({
				type: 'POST',
				data: {'page': escape(current_page), 'template-name': escape(template_name + '-' + template_id)},
				url: headway_settings['url']+'/?headway-trigger=process&process=load-template',
				success: function(data){						
					
					jQuery.ajax({
						type: 'GET',
						data: {'page-id': current_page,'is-domain-mapping':headway_is_domain_mapping},
						url: headway_settings['url']+'/?headway-trigger=process&process=visual-editor-run-up&callback=?',
						async: false,
						dataType: 'json',
						success: function(data){
							headway_settings = data['headway-settings'];

							sizing = data['sizing'];

							headway_settings['template-directory'] = headway_template_directory;														
							
							jQuery('iframe#visual-editor-contents').attr('src', jQuery('iframe#visual-editor-contents').attr('src'));
						}
					});
					
				}
			});
		});
		
		return false;
	});
	
	jQuery('a#save-template').click(function(){
		headway_open_box('save-template');
		
		return false;
	});
	
	jQuery('a#save-template-submit').click(function(){
		template_name = jQuery('input#template-name').val();
		
		current_page = jQuery('input#current-real-page').val();
		
		columns = jQuery('select#leaf-columns').val();

		column_1_width = jQuery('input#column-1-width').val();
		column_2_width = jQuery('input#column-2-width').val();
		column_3_width = jQuery('input#column-3-width').val();
		column_4_width = jQuery('input#column-4-width').val();		
		
		jQuery.ajax({ 
			type: 'POST',
			data: {'template-name':escape(template_name), 'page':escape(current_page), 'columns':escape(columns), 'column-1-width':escape(column_1_width), 'column-2-width':escape(column_2_width), 'column-3-width':escape(column_3_width), 'column-4-width':escape(column_4_width)},
			url: headway_settings['url']+'/?headway-trigger=process&process=save-leaf-template', 
			success: function(response){
				template_id = response;
								
				jQuery('div#template-selector').append('<div class="select-option" id="template-' + template_id + '"><span class="select-option-text">' + template_name + '</span><a href="#" class="template-select-edit select-edit">Edit</a></div>');
				
				jQuery('p#no-templates').hide();
				jQuery('a#load-template').show();
				jQuery('p#load-template-message').show();
				
				jQuery('input#template-name').val('Template Name');
				
				headway_bind_template_select_option('div#template-' + template_id);
				
				headway_close_box('save-template');
			}
		});
		
		return false;
	});
	
	jQuery('a#delete-template-link').click(function(){
		template_id = jQuery('input#template-settings-template-id').val();
		template_name = jQuery('input#template-settings-template-name').val();

		if(confirm('Are you sure?') === true){			
			jQuery.ajax({
				type: 'POST',
				data: {'template-id': template_id, 'template-name': template_name},
				url: headway_settings['url']+'/?headway-trigger=process&process=delete-template',
				async: false,
				success: function(data){	
					jQuery('div#'+template_id).remove();

				    headway_close_box('edit-template');

					if(jQuery('div#template-selector div.select-option').length == 0){
						jQuery('p#no-templates').show();
						jQuery('a#load-template').hide();
						jQuery('p#load-template-message').hide();
					}
				}
			});
		}

		return false;
	});
	
	
	jQuery('a#save-template-settings-button').click(function(){
		template_id = jQuery('input#template-settings-template-id').val();
		template_name = jQuery('input#template-settings-template-name').val();
		rename_input = jQuery('input#rename-template');
		
		jQuery.ajax({
			type: 'POST',
			data: {'id': template_id, 'template-name': template_name, 'new-name': rename_input.val()},
			url: headway_settings['url']+'/?headway-trigger=process&process=rename-template',
			async: false,
			success: function(data){	
				option_text.text(rename_input.val());

				headway_close_box('edit-template');
			}
		});

		return false;
	});
	
	
	jQuery('a#set-template-as-default').click(function(){
		template_id = jQuery('input#template-settings-template-id').val();
		template_name = jQuery('input#template-settings-template-name').val();
		
		jQuery.ajax({
			type: 'POST',
			data: {'id': template_id, 'template-name': template_name},
			url: headway_settings['url']+'/?headway-trigger=process&process=set-default-leafs-template',
			async: false,
			success: function(data){
				jQuery('small#default-template').remove();	
				jQuery('div#' + template_id).children('.select-option-text').append('<small id="default-template">Default</small>');

				headway_close_box('edit-template');
			}
		});

		return false;
	});
	
	
	jQuery('a#remove-template-as-default').click(function(){
		template_id = jQuery('input#template-settings-template-id').val();
		template_name = jQuery('input#template-settings-template-name').val();
		
		jQuery.ajax({
			url: headway_settings['url']+'/?headway-trigger=process&process=remove-default-leafs-template',
			async: false,
			success: function(data){
				jQuery('small#default-template').remove();	

				headway_close_box('edit-template');
			}
		});

		return false;
	});
	
	
	jQuery('a#export-template-button').click(function(){		
		var template_name = jQuery('select#export-template-selector').find(':selected').html().replace('<small id="default-template">Default</small>', '');
		var template_id = jQuery('select#export-template-selector').find(':selected').val().replace('template-', '');

		url = headway_settings['url']+'/?headway-trigger=process&process=export-leaf-template&template-id='+escape(template_name + '-' + template_id) + '&template-name='+escape(template_name);

		window.open(url);
		
		headway_close_box('export-window');	

		return false;
	});
	
	jQuery('input#disable-equal-column-heights').click(function(){
		if(jQuery(this).is(':checked')){
			jQuery('div.leafs-column').css('height', 'auto');
		} else {
			headway_equal_column_heights();
		}
	});
}